//=============================================================================
// UTVoicePack.
//=============================================================================
class UTVoicePack expands VoicePack
	Abstract;

struct VStructType
{
	var() sound SoundName;
	var() string VoiceMsg;
};
var(VGeneral) name VoiceGroups[8];
var(VTaunts) VStructType Taunts[32];
var(VTaunts) byte NumTaunts;
// Orders:
// 0 - Attack
// 1 - Defend
// 2 - Follow
// 3 - Hold this position
// 4 - Freelance (Search & Destroy).
var(VOrders) VStructType OrderVoices[5];
var(VAcknowledge) VStructType AcknowledgeV[10];
var(VAcknowledge) byte NumAcknowledges;
// 0 - Incoming
// 1 - Need backup
// 2 - Need backup 2
// 3 - Enemy flag carrier is here
// 4 - Got your back
// 5 - In position
// 6 - Negative
// 7 - Area secure
// 8 - I got flag
var(VOther) VStructType OthersV[9];
var(VSameTeam) VStructType SameTeamV[6];
var(VSameTeam) byte NumSameTeam;

Static function int GetNumVoices( name VoiceG )
{
	if( VoiceG=='Taunts' )
		Return Default.NumTaunts;
	else if( VoiceG=='Orders' )
		Return ArrayCount(Default.OrderVoices);
	else if( VoiceG=='Acknowledge' )
		Return Default.NumAcknowledges;
	else if( VoiceG=='Other' )
		Return ArrayCount(Default.OthersV);
	else if( VoiceG=='SameTeam' )
		Return Default.NumSameTeam;
	else Return -1;
}
Static function GetVoiceGroups( out name VGroups[8] )
{
	local int i;
	
	For( i=0; i<8; i++ )
		VGroups[i] = Default.VoiceGroups[i];
}
Static function string GetVoiceName( name VoiceG, byte VNum, out sound VoiceSnd )
{
	if( VoiceG=='Taunts' )
	{
		if( VNum>=Default.NumTaunts )
			VNum = Rand(Default.NumTaunts);
		VoiceSnd = Default.Taunts[VNum].SoundName;
		Return Default.Taunts[VNum].VoiceMsg;
	}
	else if( VoiceG=='Orders' )
	{
		if( VNum>=ArrayCount(Default.OrderVoices) )
			VNum = ArrayCount(Default.OrderVoices)-1;
		VoiceSnd = Default.OrderVoices[VNum].SoundName;
		Return Default.OrderVoices[VNum].VoiceMsg;
	}
	else if( VoiceG=='Acknowledge' )
	{
		if( VNum>=Default.NumAcknowledges )
			VNum = Rand(Default.NumAcknowledges);
		VoiceSnd = Default.AcknowledgeV[VNum].SoundName;
		Return Default.AcknowledgeV[VNum].VoiceMsg;
	}
	else if( VoiceG=='SameTeam' )
	{
		if( VNum>=Default.NumSameTeam )
			VNum = Rand(Default.NumSameTeam);
		VoiceSnd = Default.SameTeamV[VNum].SoundName;
		Return Default.SameTeamV[VNum].VoiceMsg;
	}
	else if( VoiceG=='Other' )
	{
		if( VNum>=ArrayCount(Default.OthersV) )
			VNum = ArrayCount(Default.OthersV)-1;
		VoiceSnd = Default.OthersV[VNum].SoundName;
		Return Default.OthersV[VNum].VoiceMsg;
	}
	else Return "";
}
Static function FillVoicesMenu( name VoiceG, out string VMsgs[32] )
{
	local byte i;
	
	if( VoiceG=='Taunts' )
	{
		For( i=0; i<Default.NumTaunts; i++ )
		{
			if( Len(Default.Taunts[i].VoiceMsg)>16 )
				VMsgs[i] = Left(Default.Taunts[i].VoiceMsg,15)$"...";
			else VMsgs[i] = Default.Taunts[i].VoiceMsg;
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%r","",False);
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%z","",False);
		}
	}
	else if( VoiceG=='Orders' )
	{
		For( i=0; i<ArrayCount(Default.OrderVoices); i++ )
		{
			if( Len(Default.OrderVoices[i].VoiceMsg)>16 )
				VMsgs[i] = Left(Default.OrderVoices[i].VoiceMsg,15)$"...";
			else VMsgs[i] = Default.OrderVoices[i].VoiceMsg;
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%r","",False);
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%z","",False);
		}
	}
	else if( VoiceG=='Acknowledge' )
	{
		For( i=0; i<Default.NumAcknowledges; i++ )
		{
			if( Len(Default.AcknowledgeV[i].VoiceMsg)>16 )
				VMsgs[i] = Left(Default.AcknowledgeV[i].VoiceMsg,15)$"...";
			else VMsgs[i] = Default.AcknowledgeV[i].VoiceMsg;
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%r","",False);
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%z","",False);
		}
	}
	else if( VoiceG=='SameTeam' )
	{
		For( i=0; i<Default.NumSameTeam; i++ )
		{
			if( Len(Default.SameTeamV[i].VoiceMsg)>16 )
				VMsgs[i] = Left(Default.SameTeamV[i].VoiceMsg,15)$"...";
			else VMsgs[i] = Default.SameTeamV[i].VoiceMsg;
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%r","",False);
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%z","",False);
		}
	}
	else if( VoiceG=='Other' )
	{
		For( i=0; i<ArrayCount(Default.OthersV); i++ )
		{
			if( Len(Default.OthersV[i].VoiceMsg)>16 )
				VMsgs[i] = Left(Default.OthersV[i].VoiceMsg,15)$"...";
			else VMsgs[i] = Default.OthersV[i].VoiceMsg;
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%r","",False);
			VMsgs[i] = Class'DeathMatchPlus'.Static.ReplaceText(VMsgs[i],"%z","",False);
		}
	}
}

defaultproperties
{
				VoiceGroups(0)="Taunts"
				VoiceGroups(1)="Orders"
				VoiceGroups(2)="Acknowledge"
				VoiceGroups(3)="SameTeam"
				VoiceGroups(4)="Other"
				OrderVoices(0)=(VoiceMsg="Assault the base! %r")
				OrderVoices(1)=(VoiceMsg="Defend the base! %r")
				OrderVoices(2)=(VoiceMsg="Cover me! %r")
				OrderVoices(3)=(VoiceMsg="Hold this position! %r")
				OrderVoices(4)=(VoiceMsg="Search & Destroy! %r")
				AcknowledgeV(0)=(VoiceMsg="%r Got it!")
				NumAcknowledges=1
				OthersV(0)=(VoiceMsg="Incoming! %z")
				OthersV(1)=(VoiceMsg="I'm under heavy attack. %z")
				OthersV(2)=(VoiceMsg="I need some backup! %z")
				OthersV(3)=(VoiceMsg="Enemy flag carrier is here! %z")
				OthersV(4)=(VoiceMsg="%r I've got you'r back.")
				OthersV(5)=(VoiceMsg="I'm in position! %z")
				OthersV(6)=(VoiceMsg="Negative!")
				OthersV(7)=(VoiceMsg="Area secure! %z")
				OthersV(8)=(VoiceMsg="I got the flag! %z")
}
